indexing
	description: "Anwendungs-Hauptfenster"
				 "die grafische Benutzer Schnittstelle"

class
	ANWENDUNGS_FENSTER

inherit
	WEL_FRAME_WINDOW
	redefine
		on_paint, on_control_command, class_background
	end

creation
	make

feature {NONE}

	-- Hintergrund Farbe
	class_background: WEL_BRUSH is
	once
		create Result.make_by_sys_color (1) -- grau,
	end

	-- Vermittler und Kollegen
	vermittler: VERMITTLER
	kollege_1: KOLLEGE1
	kollege_2: KOLLEGE2
	kollege_3: KOLLEGE3

	-- Interaktionselemente und andere Bildschirm-Ausgabe-Funktionen
	dc: WEL_CLIENT_DC;
    rahmen_1, rahmen_2, rahmen_3: WEL_GROUP_BOX
	anmelden_1_button, anmelden_2_button, anmelden_3_button: WEL_PUSH_BUTTON;
	abmelden_1_button, abmelden_2_button, abmelden_3_button: WEL_PUSH_BUTTON;
	senden_1_button, senden_2_button, senden_3_button: WEL_PUSH_BUTTON;
	koll_1_angemeldet, koll_2_angemeldet, koll_3_angemeldet: BOOLEAN;
	edit_1, edit_2, edit_3: WEL_SINGLE_LINE_EDIT
	kurze_beschreibung, kurze_anleitung: WEL_STATIC

	-- zeichne das Chat-Fenster, zeige welche Kollegen angemeldet sind
	draw_chat (pdc: WEL_DC) is
	local
		-- lokale Koordinaten
		xx, yy: INTEGER
		-- Farben fuer Schrift im Chat-Fenster
		bg_color: WEL_COLOR_REF
	do
		xx := 290;
		yy := 020;
		!!bg_color.make_rgb(255,255,255);
		pdc.rectangle ( xx, yy -5 , xx + 120, yy + 90 ); -- links, oben, rechts, unten
		pdc.text_out ( xx + 25, yy + 2, "Vermittler"); -- x, y
		if koll_1_angemeldet then
			bg_color.set_rgb(255,100,200);
			pdc.set_background_color (bg_color);
			pdc.text_out (xx + 15, yy + 25, "1 angemeldet");
		end
		if koll_2_angemeldet then
			bg_color.set_rgb(200,200,255);
			pdc.set_background_color (bg_color);
			pdc.text_out (xx + 15, yy + 45, "2 angemeldet");
		end
		if koll_3_angemeldet then
			bg_color.set_rgb(180,255,170);
			pdc.set_background_color (bg_color);
			pdc.text_out (xx + 15, yy + 65, "3 angemeldet");
		end
	end

	-- Zeichne das Chat-Fenster neu
	repaint_chat is
	do
		dc.get;
		draw_chat (dc);
		dc.release;
	end;

	-- reagiere auf eine Zeichne_neu Aufforderung
	on_paint (pdc: WEL_PAINT_DC; invalid_rect: WEL_RECT) is
	do
		draw_chat (pdc);
	end;

	-- reagiere auf das Druecken von Knoepfen
	on_control_command (a_control: WEL_CONTROL) is
	local
	do
		-- Anmelden Knoepfe
		if a_control = anmelden_1_button then
			koll_1_angemeldet := true
			kollege_1.setzeVermittler (vermittler)
			repaint_chat
			kollege_1.sendeNachricht ("1 neu im chat")
		elseif a_control = anmelden_2_button then
			koll_2_angemeldet := true
			kollege_2.setzeVermittler (vermittler)
			repaint_chat
			kollege_2.sendeNachricht ("2 neu im chat")
		elseif a_control = anmelden_3_button then
			koll_3_angemeldet := true
			kollege_3.setzeVermittler (vermittler)
			repaint_chat
			kollege_3.sendeNachricht ("3 neu im chat")

		-- Abmelden Knoepfe
		elseif a_control = abmelden_1_button and koll_1_angemeldet then
			kollege_1.sendeNachricht ("1 verlsst chat")
			koll_1_angemeldet := false
			vermittler.abmeldeKollege (kollege_1)
			repaint_chat
		elseif a_control = abmelden_2_button and koll_2_angemeldet then
			kollege_2.sendeNachricht ("2 verlsst chat")
			koll_2_angemeldet := false
			vermittler.abmeldeKollege (kollege_2)
			repaint_chat
		elseif a_control = abmelden_3_button and koll_3_angemeldet then
			kollege_3.sendeNachricht ("3 verlsst chat")
			koll_3_angemeldet := false
			vermittler.abmeldeKollege (kollege_3)
			repaint_chat

		-- Senden Knoepfe
		elseif a_control = senden_1_button and koll_1_angemeldet then
			kollege_1.sendeNachricht ("1: " + edit_1.text)
			edit_1.clear
		elseif a_control = senden_2_button and koll_2_angemeldet then
			kollege_2.sendeNachricht ("2: " + edit_2.text)
			edit_2.clear
		elseif a_control = senden_3_button and koll_3_angemeldet then
			kollege_3.sendeNachricht ("3: " + edit_3.text)
			edit_3.clear
		end;
	end;

feature {ANY}

	make is
	do
		-- erstelle und konfiguriere das Fenster
		make_top ("Demonstration: Vermittler (Mediator)");
		resize (705, 420);
		!! dc.make (Current);
		!! kurze_beschreibung.make (Current,
				"Mit dem Chat knnen nun alle gleichzeitig miteinander %
				%kommunizieren.", 30, 30, 200, 70, -1);
		!! kurze_anleitung.make (Current,
				"1. Anmelden-Knopf drcken %
				%2. Nachrichten schreiben  %
				%3. Senden-Knopf drcken   %
				%4. Nachrichten lesen", 480, 30, 180, 70, -1);

		-- erstelle Mediator und Kollegen
		!! vermittler.make
		!! kollege_1.make (Current, 030, 270, 180, 100, -1);
		!! kollege_2.make (Current, 260, 270, 180, 100, -1);
		!! kollege_3.make (Current, 490, 270, 180, 100, -1);

		-- erstelle die Interaktionselemente
		!! rahmen_1.make (Current, "Kollege 1", 10, 150, 220, 235, -1);
		!! rahmen_2.make (Current, "Kollege 2", 240, 150, 220, 235, -1);
		!! rahmen_3.make (Current, "Kollege 3", 470, 150, 220, 235, -1);

		!! anmelden_1_button.make (Current, "Anmelden", 030, 180, 80, 20, -1);
		!! anmelden_2_button.make (Current, "Anmelden", 260, 180, 80, 20, -1);
		!! anmelden_3_button.make (Current, "Anmelden", 490, 180, 80, 20, -1);

		!! abmelden_1_button.make (Current, "Abmelden", 130, 180, 80, 20, -1);
		!! abmelden_2_button.make (Current, "Abmelden", 360, 180, 80, 20, -1);
		!! abmelden_3_button.make (Current, "Abmelden", 590, 180, 80, 20, -1);

		!! edit_1.make (Current, "hier schreiben", 030, 210, 180, 25, -1);
		!! edit_2.make (Current, "...",            260, 210, 180, 25, -1);
		!! edit_3.make (Current, "...",            490, 210, 180, 25, -1);

		!! senden_1_button.make (Current, "Senden", 090, 240, 55, 20, -1);
		!! senden_2_button.make (Current, "Senden", 320, 240, 55, 20, -1);
		!! senden_3_button.make (Current, "senden", 540, 240, 55, 20, -1);
	end;

end
